<?php

namespace App\Http\Controllers\Api;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;

use Illuminate\Support\Facades\Hash;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Str;


use App\Traits\ValidationTrait;
use App\Traits\ProfileTrait;

use App\Models\User;


use Carbon\Carbon;
use Exception;
use DB;

class AuthController extends Controller
{

    use ValidationTrait, ProfileTrait;
    public $platform='app';

    public function register(Request $request)
    {
        // try{
            if(!$this->isValid($request->all(), 'register', 0, $this->platform))
            {
                $vErrors = $this->getVErrorMessages($this->vErrors);
                return response()->json(['status' => 0, 'msg' => $vErrors, 'payload' => ['verrors' => $vErrors]], config('constants.vErr'));
            }

            $values=$request->only('name', 'email', 'phone', 'addr', 'pass');

            // $uniqueUserId=$this->generateUniqueUserId();            

            $user=new User;
            // $user->uniqueUserId=$uniqueUserId;
            $user->name=Str::title($values['name']);            
            $user->email=$values['email'];
            $user->phone=$values['phone'];
            $user->addr=$values['addr'];
            $user->pass=base64_encode($values['pass']);
            $user->user_type='user';
            $user->save();

            return response()->json(['status' => 1, 'msg' => __('messages.registerSuccess')], config('constants.ok'));
               
        // }
        // catch(Exception $e)
        // {
        //     return response()->json(['status' => 0, 'msg' => __('messages.serverErrMsg'), 'payload' => (object)[]], config('constants.serverErr'));
        // }

    }


    public function login(Request $request)
    {
        try{
            if(!$this->isValid($request->all(), 'login', 0, $this->platform))
            {
                $vErrors = $this->getVErrorMessages($this->vErrors);
                return response()->json(['status' => 0, 'msg' => $vErrors, 'payload' => ['verrors' => $vErrors]], config('constants.vErr'));
            }

            $values=$request->only('email', 'pass');
            $email=$values['email'];
            $pass=$values['pass'];

          
            $column = 'email';
            $msg = 'Invalid email or password.';
            $credentials = ['email' => $email, 'pass' => $pass];
           

            // $isBlocked = User::where($column, $email)->where('status', '0')->get();
            // if ($isBlocked->count() > 0) {
            //     return response()->json([
            //         'status' => 0,
            //         'msg' => __('messages.blockMsg'),
            //         'payload' => (object)[]
            //     ], config('constants.ok'));
            // }
           
           
            $pass = base64_encode($values['pass']);
            $user = User::where($column , $email)->where('pass', $pass)->first();

            if($user){
                Auth::loginUsingId($user->id);
                $user = Auth::user();

                //Revoke old active token (Mutiple login not allowed)
                // $user->tokens()->delete();
                $token = $user->createToken("API TOKEN")->plainTextToken;
                if ($token) {

                    $param = array(
                        'user'=>$user,
                        'platform'=>$this->platform
                    );
                    $data = $this->getProfileInfo($param, $this->platform);
                    if ($data === false) {
                        return response()->json(['status' => 0, 'msg' => __('messages.serverErrMsg'), 'payload' => (object)[]],  config('constants.serverErr'));
                    } else {
                        return response()->json(['status' => 1, 'msg' => __('messages.loginSuccess'), "payload" => ['tokenType' => 'Bearer', 'token' => $token, 'user' => $data]], config('constants.ok'));
                    }
                } else {
                    return response()->json(['status' => 0, 'msg' => __('messages.serverErrMsg'), 'payload' => (object)[]], config('constants.ok'));
                }
            } else {
                return response()->json(['status' => 0, 'msg' => $msg, 'payload' => (object)[]],  config('constants.ok'));
            }
        }
        catch(Exception $e)
        {
            return response()->json(['status' => 0, 'msg' => __('messages.serverErrMsg'), 'payload' => (object)[]], config('constants.serverErr'));
        }
    }
   

    public function logout(Request $request)
    {        
       
        $request->user()->tokens()->delete();
        return response()->json([
            'status' => 1,
            'msg' => 'Successfully logged out.',
            'payload' => (object)[],
        ], config('constants.ok'));
    }



    public function getMyProfile(Request $request)
    {
        try{
            $param = array(
                        'user'=>$request->user(),
                        'platform'=>$this->platform
                    );
            $data=$this->getProfileInfo($param, $this->platform);
            if($data===false)
            {
                return response()->json(['status' => 0, 'msg' => __('messages.serverErrMsg'), 'payload' => (object)[]], config('constants.serverErr'));
            }

            return response()->json(['status' => 1, 'msg' => __('messages.successMsg'), 'payload' => ['user'=>$data]], config('constants.ok'));
        }
        catch(Exception $e)
        {
            return response()->json(['status' => 0, 'msg' => __('messages.serverErrMsg'), 'payload' => (object)[]], config('constants.serverErr'));
        }
    }
    
   


}
