<?php

namespace app\Traits;


use Validator;

trait ValidationTrait
{

    public function isValid($input, $case = 'create', $id = 0, $platform)
    {
        if ($platform == 'backend') {
            $response=$this->vRulesBackend($input, $case, $id);
            $rules=$response[0];
            $messages=$response[1];
            $validator = Validator::make($input, $rules, $messages);

            //$validator = Validator::make($input, $this->vRulesBackend($input, $case, $id));

            return $validator;
        } elseif ($platform == 'web') {
            $validator = Validator::make($input, $this->vRulesWeb($input, $case, $id));

            return $validator;

            // if($validation->passes()) return true;
            // $this->vErrors = $validation->messages();

            // return false;
        } elseif ($platform == 'app') {
            $validator = Validator::make($input, $this->vRulesApp($input, $case, $id));
            if ($validator->passes()) {
                return true;
            }
            $this->vErrors = $validator->messages();
            return false;
        } else {
        }
        //$validation->setAttributeNames(static::$niceNames);
    }
    public function vRulesBackend($input, $case = 'create', $id = 0)
    {
     
    }


   public function vRulesApp($input, $case = 'create', $id = 0)
    {
        $rules = [];
        
        switch ($case) {           


            case 'login':
                $rules = [
                    'email' => 'required',
                    'pass' => 'required|min:5|max:20',
                ];
                break; 
                $messages = [
                    'pass.required'=>'Password field is required.'
                ];  
  
            case 'register':
                $rules = [
                    'name'=>'required|max:50',                    
                    'email' => 'required|email|max:100|unique:users',
                    'phone' => 'required|digits:10|unique:users',
                    'addr'=>'required|max:100',
                    'pass' => 'required|min:5|max:20',
                ];
                break; 
                $messages = [
                    'pass.required'=>'Password field is required.'
                ];               

            case 'updateDeviceToken':
                $rules = [
                    'deviceType' => 'required',
                    'deviceToken' => 'required',
                ];
                break;


            case 'forgotPassword':
                $rules = [
                    'email' => 'required|email',
                ];
                break;

            case 'resetPassword':
                $rules = [
                    'userId' => 'required|min:1|regex:/^[1-9][0-9]*$/',
                    'password' => 'required|min:6|max:20',
                ];
                break;


            //ProfileController
            case 'uploadProfilePic':
                $rules = [
                    'profilePic' => 'required',
                ];
                break;
                    
            case 'changePassword':
                $rules = [
                    'currentPassword' => 'required',
                    'newPassword' => 'required|min:6|max:20',
                ];
                break; 

        }

        return $rules;
    }

    public function getVErrorMessages($vErrors)
    {
        $ret = [];
        $messages = $vErrors->getMessages();
        if (is_array($messages) && count($messages) > 0) {
            foreach ($messages as $k => $v) {
                if (is_array($v) && array_key_exists(0, $v)) {
                    // $ret[$k] = $v[0];
                    return $v[0];
                }
            }
        }
        //return $ret;
    }
}
